;       ,  
;         
;           -
;       
;				*****
;
R7              .EQU    7       ;  R0-R7
R6              .EQU    6
R5              .EQU    5
R4              .EQU    4
R3              .EQU    3
R2              .EQU    2
R1              .EQU    1
R0              .EQU    0
ACC             .EQU    0E0H    ; 
B               .EQU    0F0H    ;  
PSW             .EQU    0D0H    ;  () 
SP              .EQU    81H     ;  
DPL             .EQU    82H     ;   DPTR
DPH             .EQU    83H     ;   DPTR
P0              .EQU    80H     ;   0
P1              .EQU    90H     ;   1
P2              .EQU    0A0H    ;   2
P3              .EQU    0B0H    ;   3
B.0             .EQU    0F0H    ;    
B.1             .EQU    0F1H
B.2             .EQU    0F2H
B.3             .EQU    0F3H
B.4             .EQU    0F4H
B.5             .EQU    0F5H
B.6             .EQU    0F6H
B.7             .EQU    0F7H
ACC.0           .EQU    0E0H    ;   
ACC.1           .EQU    0E1H
ACC.2           .EQU    0E2H
ACC.3           .EQU    0E3H
ACC.4           .EQU    0E4H
ACC.5           .EQU    0E5H
ACC.6           .EQU    0E6H
ACC.7           .EQU    0E7H
PSW.0           .EQU    0D0H    ;    PSW
PSW.1           .EQU    0D1H
PSW.2           .EQU    0D2H
PSW.3           .EQU    0D3H
PSW.4           .EQU    0D4H
PSW.5           .EQU    0D5H
PSW.6           .EQU    0D6H
PSW.7           .EQU    0D7H
P0.0            .EQU    080H    ;    0
P0.1            .EQU    081H
P0.2            .EQU    082H
P0.3            .EQU    083H
P0.4            .EQU    084H
P0.5            .EQU    085H
P0.6            .EQU    086H
P0.7            .EQU    087H
P1.0            .EQU    090H    ;    1
P1.1            .EQU    091H
P1.2            .EQU    092H
P1.3            .EQU    093H
P1.4            .EQU    094H
P1.5            .EQU    095H
P1.6            .EQU    096H
P1.7            .EQU    097H
P2.0            .EQU    0A0H    ;    2
P2.1            .EQU    0A1H
P2.2            .EQU    0A2H
P2.3            .EQU    0A3H
P2.4            .EQU    0A4H
P2.5            .EQU    0A5H
P2.6            .EQU    0A6H
P2.7            .EQU    0A7H
P3.0            .EQU    0B0H    ;    3
P3.1            .EQU    0B1H
P3.2            .EQU    0B2H
P3.3            .EQU    0B3H
P3.4            .EQU    0B4H
P3.5            .EQU    0B5H
P3.6            .EQU    0B6H
P3.7            .EQU    0B7H
;
;
        .ORG  0                         ;    0
;
        LJMP    START                   ;    START
;
        .ORG    100H                    ;    100
;
START:                                  ;,  
        MOV     DPTR,#0FF00H            ;  R3  R2  
        MOV     R2,DPL                  ;  
        MOV     R3,DPH                  ;   -
        LCALL   BN2BCD                  ;
        SJMP    START
;
BN2BCD:                                 ;   R3R2
                                        ;(.  R2)
        MOV     R4,#0                   ; 
        MOV     R5,#0
        MOV     R6,#0
        MOV     R7,#0
;
        MOV     DPTR,#10000
BN2_1:
        LCALL   R32MNDPT                ;R3R2 - 10000
        JC      BN2_2                   ;.  BN2_2,  CY=1
        INC     R6                      ;R6=R6 + 1 -  ,  CY=0
        SJMP    BN2_1                   ;  BN2_1
BN2_2:
        LCALL   R32PLDPT                ;R3R2 + 10000
;
        MOV     DPTR,#1000
BN2_3:
        LCALL   R32MNDPT                ;R3R2 - 1000
        JC      BN2_4                   ;.  BN2_4,  CY=1
        INC     R7                      ;R7=R7 + 1 -  ,  CY=0
        SJMP    BN2_3                   ;  BN2_3
BN2_4:
        LCALL   R32PLDPT                ;R3R2 + 1000
;
        MOV     DPTR,#100
BN2_5:
        LCALL   R32MNDPT                ;R3R2 - 100
        JC      BN2_6                   ;.  BN2_6,  CY=1
        INC     R5                      ;R5=R5 + 1 -  ,  CY=0
        SJMP    BN2_5                   ;  BN2_5
BN2_6:
        LCALL   R32PLDPT
;
        MOV     A,R7                    ;  R7  A
        SWAP    A                       ;    
                                        ; A
        ADD     A,R5                    ;  A R5
        MOV     R5,A                    ;   R5
        MOV     R7,#0                   ;R7 = 0
;
        MOV     DPTR,#10
BN2_7:
        LCALL   R32MNDPT                ;R3R2 - 10
        JC      BN2_8                   ;.  BN2_8,  CY=1
        INC     R7                      ;R7=R7 + 1 -  ,  CY=0
        SJMP    BN2_7                   ;  BN2_7
BN2_8:
        LCALL   R32PLDPT                ;R3R2 + 10
;
        MOV     A,R2
        MOV     R4,A                    ;R2     R4
;
        MOV     A,R7                    ;  R7  A
        SWAP    A                       ;    
                                        ; A
        ADD     A,R4                    ;  A R4
        MOV     R4,A                    ;   R4
        RET                             ;  
;
;  BN2BCD
;
R32PLDPT:
        MOV     A,R2                    ;R2  
        ADD     A,DPL                   ;   . DPTR
        MOV     R2,A                    ;   R2
        MOV     A,R3                    ;R3  
        ADDC    A,DPH                   ;    
                                        ;  . DPTR
        MOV     R3,A                    ;   R3
        RET
;
R32MNDPT:
        CLR     C                       ; CY
        MOV     A,R2                    ;R2  
        SUBB    A,DPL                   ;   . DPTR  Y
        MOV     R2,A                    ;   R2
        MOV     A,R3                    ;R3  
        SUBB    A,DPH                   ;    
                                        ; . DPTR
        MOV     R3,A                    ;   R3
        RET
;
;
;
.END
