
;                         
;                            *****
;
;
	  #INCLUDE "DEFS.INC"	
;
CHISLO1 .EQU    100
CHISLO  .EQU    65536-CHISLO1
;
;
;                :
;                   *****
;
        .ORG     0
;
        LJMP    WORK
;
;
        .ORG     0BH		;    0BH
;
        LJMP    TIMER0		;   
;				;  - 0
;
        .ORG     100H		;    100H
;			
WORK:				; - 
				; 
	CLR     TR0
        CLR     TR1             ; 
 	MOV     IP,#0           ;  
        MOV     IE,#0           ;  
  	MOV     TMOD,#00000001B ;0-GATE1, 0-C/T1#, 00-  1
                                ;0-GATE0, 0-C/T0#, 01-  0
  	MOV     DPTR,#CHISLO
        MOV     TL0,DPL
        MOV     TH0,DPH         ; 0  
  				; 65535-CHISLO1
        SETB    ET0             ;   0
        SETB    EA              ;  
        SETB    TR0             ;  0
;
;  ,     , 
;     TL0,TH0  0FFFFH
;
        SJMP    $
;
;
TIMER0:
        CLR     TR0             ; 
        CLR     EA              ; 
        PUSH    PSW
        PUSH    ACC             ;   
        PUSH    DPL
        PUSH    DPH
;
        MOV     C,P1.0
        MOV     P1.1,C          ; 1.1  ,    1.0
        CPL     C		;  1.0
        MOV     P1.0,C          ;  1.0  1.0
;
        MOV     DPTR,#CHISLO
        MOV     TL0,DPL
        MOV     TH0,DPH         ;   0 
;
        POP     DPH
        POP     DPL
        POP     ACC
        POP     PSW             ;   
        SETB    EA              ; 
        SETB    TR0             ;  0
        RETI                    ;  
                                ;  
;
	.END




;
;                         
;                            *****
;
;
;
R15     .EQU    15           
R14     .EQU    14           
R13     .EQU    13           
R12     .EQU    12           
R11     .EQU    11           
R10     .EQU    10           
R9      .EQU    9            
R8      .EQU    8            
R7      .EQU    7            
R6      .EQU    6            
R5      .EQU    5            
R4      .EQU    4            
R3      .EQU    3            
R2      .EQU    2            
R1      .EQU    1            
R0      .EQU    0            
ACC     .EQU    0E0H         
B       .EQU    0F0H         
PSW     .EQU    0D0H         
SP      .EQU    81H          
DPL     .EQU    82H
DPH     .EQU    83H
P0      .EQU    80H
P1      .EQU    90H
P2      .EQU    0A0H
P3      .EQU    0B0H
B.0     .EQU    0F0H
B.1     .EQU    0F1H
B.2     .EQU    0F2H
B.3     .EQU    0F3H
B.4     .EQU    0F4H
B.5     .EQU    0F5H
B.6     .EQU    0F6H
B.7     .EQU    0F7H
ACC.0   .EQU    0E0H
ACC.1   .EQU    0E1H
ACC.2   .EQU    0E2H
ACC.3   .EQU    0E3H
ACC.4   .EQU    0E4H
ACC.5   .EQU    0E5H
ACC.6   .EQU    0E6H
ACC.7   .EQU    0E7H
PSW.0   .EQU    0D0H
PSW.1   .EQU    0D1H
PSW.2   .EQU    0D2H
PSW.3   .EQU    0D3H
PSW.4   .EQU    0D4H
PSW.5   .EQU    0D5H
PSW.6   .EQU    0D6H
PSW.7   .EQU    0D7H
P0.0    .EQU    080H
P0.1    .EQU    081H
P0.2    .EQU    082H
P0.3    .EQU    083H
P0.4    .EQU    084H
P0.5    .EQU    085H
P0.6    .EQU    086H
P0.7    .EQU    087H
P1.0    .EQU    090H
P1.1    .EQU    091H
P1.2    .EQU    092H
P1.3    .EQU    093H
P1.4    .EQU    094H
P1.5    .EQU    095H
P1.6    .EQU    096H
P1.7    .EQU    097H
P2.0    .EQU    0A0H
P2.1    .EQU    0A1H
P2.2    .EQU    0A2H
P2.3    .EQU    0A3H;
P2.4    .EQU    0A4H;
P2.5    .EQU    0A5H;
P2.6    .EQU    0A6H;
P2.7    .EQU    0A7H;
P3.0    .EQU    0B0H;
P3.1    .EQU    0B1H;
P3.2    .EQU    0B2H;
P3.3    .EQU    0B3H;
P3.4    .EQU    0B4H;
P3.5    .EQU    0B5H;
P3.6    .EQU    0B6H;
P3.7    .EQU    0B7H;
;
TMOD    .EQU    089H
TCON    .EQU    088H
TL0     .EQU    08AH
TH0     .EQU    08CH
IE      .EQU    0A8H
IP      .EQU    0B8H
TR0     .EQU    08CH
TR1     .EQU    08EH
ET0     .EQU    0A9H
EA      .EQU    0AFH
;
;














