;
;       &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
;       &                                                       &
;       &                     &
;       &                 AT89C51                  &
;       &                                                       &
;       &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
;
;
;
;                         
;                            *****
;
;
;
R15     .EQU    15           ;Ŀ
R14     .EQU    14           ; CPU   1 P1.0
R13     .EQU    13           ;       2 P1.1
R12     .EQU    12           ;      3 P1.2
R11     .EQU    11           ;      4 P1.3
R10     .EQU    10           ;      5 P1.4
R9      .EQU    9            ;      6 P1.5
R8      .EQU    8            ;      7 P1.6
R7      .EQU    7            ;      8 P1.7
R6      .EQU    6            ;         Ĵ
R5      .EQU    5            ;             
R4      .EQU    4            ;      10P3.0
R3      .EQU    3            ;      11P3.1
R2      .EQU    2            ;      12P3.2
R1      .EQU    1            ;      13P3.3
R0      .EQU    0            ;      14P3.4
ACC     .EQU    0E0H         ;      15P3.5
B       .EQU    0F0H         ;      16P3.6
PSW     .EQU    0D0H         ;       17P3.7
SP      .EQU    81H          ;
DPL     .EQU    82H
DPH     .EQU    83H
P0      .EQU    80H
P1      .EQU    90H
P2      .EQU    0A0H
P3      .EQU    0B0H
B.0     .EQU    0F0H
B.1     .EQU    0F1H
B.2     .EQU    0F2H
B.3     .EQU    0F3H
B.4     .EQU    0F4H
B.5     .EQU    0F5H
B.6     .EQU    0F6H
B.7     .EQU    0F7H
ACC.0   .EQU    0E0H
ACC.1   .EQU    0E1H
ACC.2   .EQU    0E2H
ACC.3   .EQU    0E3H
ACC.4   .EQU    0E4H
ACC.5   .EQU    0E5H
ACC.6   .EQU    0E6H
ACC.7   .EQU    0E7H
PSW.0   .EQU    0D0H
PSW.1   .EQU    0D1H
PSW.2   .EQU    0D2H
PSW.3   .EQU    0D3H
PSW.4   .EQU    0D4H
PSW.5   .EQU    0D5H
PSW.6   .EQU    0D6H
PSW.7   .EQU    0D7H
P0.0    .EQU    080H
P0.1    .EQU    081H
P0.2    .EQU    082H
P0.3    .EQU    083H
P0.4    .EQU    084H
P0.5    .EQU    085H
P0.6    .EQU    086H
P0.7    .EQU    087H
P1.0    .EQU    090H
P1.1    .EQU    091H
P1.2    .EQU    092H
P1.3    .EQU    093H
P1.4    .EQU    094H
P1.5    .EQU    095H
P1.6    .EQU    096H
P1.7    .EQU    097H
P2.0    .EQU    0A0H
P2.1    .EQU    0A1H
P2.2    .EQU    0A2H
P2.3    .EQU    0A3H;
P2.4    .EQU    0A4H;
P2.5    .EQU    0A5H;
P2.6    .EQU    0A6H;
P2.7    .EQU    0A7H;
P3.0    .EQU    0B0H;
P3.1    .EQU    0B1H;
P3.2    .EQU    0B2H;
P3.3    .EQU    0B3H;
P3.4    .EQU    0B4H;
P3.5    .EQU    0B5H;
P3.6    .EQU    0B6H;
P3.7    .EQU    0B7H;
;
TMOD    .EQU    089H
TCON    .EQU    088H
TL0     .EQU    08AH
TH0     .EQU    08CH
IE      .EQU    0A8H
IP      .EQU    0B8H
TR0     .EQU    08CH
TR1     .EQU    08EH
ET0     .EQU    0A9H
EA      .EQU    0AFH
;
CN16BIT .EQU    050H
CN1_0   .EQU    052H
CHISLO  .EQU    65536-100
;
;
;
;
;
;
;                :
;                   *****
;
        .ORG     0
;
        LJMP    WORK
;
;
;
        .ORG     0BH
;
        LJMP    TIMER0
;
;
;
        .ORG     100H
;
WORK:
        MOV     TMOD,#00000001B ;0-GATE1, 0-C/T1#, 00-  1
;                               ;0-GATE0, 0-C/T0#, 01-  0
        CLR     TR0
        CLR     TR1             ; 
        MOV     DPTR,#CHISLO
        MOV     TL0,DPL
        MOV     TH0,DPH         ; 0   500 
        MOV     IP,#0           ;  
        MOV     IE,#0           ;  
;
        SETB    ET0             ;   0
        SETB    EA              ; 
        SETB    TR0             ;  0
;
;  ,     , 
;     TL0,TH0  0FFFFH
;
        SJMP    $
;
;
;
TIMER0:
        CLR     TR0             ; 
;        CLR     EA              ; 
        PUSH    PSW
        PUSH    ACC             ; PSW  ACC  
        PUSH    DPL
        PUSH    DPH
;
        MOV     C,P1.0
        MOV     P1.1,C          ;
        CPL     C
        MOV     P1.0,C          ;
;
        MOV     DPTR,#CHISLO
        MOV     TL0,DPL
        MOV     TH0,DPH         ; 0   500 
;
        POP     DPH
        POP     DPL
        POP     ACC
        POP     PSW             ;   
;        SETB    EA              ;M 
        SETB    TR0             ;  0
        RETI                    ;  
                                ;  
;
;
;
;                
;
;/ MUL21     
;   16*8=24 (   
;.- ,- DE,- (,H,L)
;  , DE.
MUL21:                  ;R0*R5R4=R0R5R4, R0  R1 O.
        MOV     R2,#8
        MOV     A,#0
        MOV     R3,A
        MOV     R6,A
        MOV     R7,A
LOOP67: MOV     A,R6
        ADD     A,R6
        MOV     R6,A
        MOV     A,R7
        ADDC    A,R7
        MOV     R7,A
        MOV     A,R0
        ADDC    A,R0
        MOV     R0,A
        JNC     LOOP68
        MOV     A,R6
        ADD     A,R4
        MOV     R6,A
        MOV     A,R7
        ADDC    A,R5
        MOV     R7,A
        MOV     A,R0
        ADDC    A,R3
        MOV     R0,A
LOOP68: DJNZ    R2,LOOP67
        MOV     A,R6
        MOV     R4,A
        MOV     A,R7
        MOV     R5,A
        RET
;
;
;
;separate subroutines
HLCMDE:CLR  C
       MOV  A,R7
       SUBB A,R5
       JNZ  RETHCD
       MOV  A,R6
       SUBB A,R4
RETHCD:RET
DECMBC:CLR  C
       MOV  A,R5
       SUBB A,R3
       JNZ  RETDCB
       MOV  A,R4
       SUBB A,R2
RETDCB:RET
BCCMHL:CLR  C
       MOV  A,R3
       SUBB A,R7
       JNZ  RETBCH
       MOV  A,R2
       SUBB A,R6
RETBCH:RET
BCCMDE:CLR  C
       MOV  A,R3
       SUBB A,R5
       JNZ  RETBCD
       MOV  A,R2
       SUBB A,R4
RETBCD:RET
;
DEMNBC:CLR  C
       MOV  A,R4
       SUBB A,R2
       MOV  R4,A
       MOV  A,R5
       SUBB A,R3
       MOV  R5,A
       RET
BCMNHL:CLR  C
       MOV  A,R2
       SUBB A,R6
       MOV  R2,A
       MOV  A,R3
       SUBB A,R7
       MOV  R3,A
       RET
BCMNDE:CLR  C
       MOV  A,R2
       SUBB A,R4
       MOV  R2,A
       MOV  A,R3
       SUBB A,R5
       MOV  R3,A
       RET
HLMNBC:CLR  C
       MOV  A,R6
       SUBB A,R2
       MOV  R6,A
       MOV  A,R7
       SUBB A,R3
       MOV  R7,A
       RET
;
HLMNDE:CLR  C
       MOV  A,R6
       SUBB A,R4
       MOV  R6,A
       MOV  A,R7
       SUBB A,R5
       MOV  R7,A
       RET
;
DADB:  MOV  A,R6
       ADD  A,R2
       MOV  R6,A
       MOV  A,R7
       ADDC A,R3
       MOV  R7,A
       RET
DADD:  MOV  A,R6
       ADD  A,R4
       MOV  R6,A
       MOV  A,R7
       ADDC A,R5
       MOV  R7,A
       RET
DE2:   CLR  C
       MOV  A,R4
       RLC  A
       MOV  R4,A
       MOV  A,R5
       RLC  A
       MOV  R5,A
       RET
HL2:   CLR  C
       MOV  A,R6
       RLC  A
       MOV  R6,A
       MOV  A,R7
       RLC  A
       MOV  R7,A
       RET
;
DEXGHL:XCH  A,R6
       XCH  A,R4
       XCH  A,R6
       XCH  A,R7
       XCH  A,R5
       XCH  A,R7
       RET
BCXGHL:XCH  A,R6
       XCH  A,R2
       XCH  A,R6
       XCH  A,R7
       XCH  A,R3
       XCH  A,R7
       RET
BCXGDE:XCH  A,R4
       XCH  A,R2
       XCH  A,R4
       XCH  A,R5
       XCH  A,R3
       XCH  A,R5
       RET
;
POSB:  CLR  C
       MOV  A,R3
       RRC  A
       MOV  R3,A
       MOV  A,R2
       RRC  A
       MOV  R2,A
       RET
POSD:  CLR  C
       MOV  A,R5
       RRC  A
       MOV  R5,A
       MOV  A,R4
       RRC  A
       MOV  R4,A
       RET
;
DOPD:  MOV  A,R4
       CPL  A
       MOV  R4,A
       MOV  A,R5
       CPL  A
       MOV  R5,A
       SJMP INXD
;
INXB:  MOV  A,R2
       ADD  A,#1
       MOV  R2,A
       MOV  A,R3
       ADDC A,#0
       MOV  R3,A
INXBEN:RET
;
INXD:  MOV  A,R4
       ADD  A,#1
       MOV  R4,A
       MOV  A,R5
       ADDC A,#0
       MOV  R5,A
INXDEN:RET
;
INXH:  MOV  A,R6
       ADD  A,#1
       MOV  R6,A
       MOV  A,R7
       ADDC A,#0
       MOV  R7,A
INXHEN:RET
;
DECDPTR:MOV     A,DPL
        ADD     A,#0FFH
        MOV     DPL,A
        MOV     A,DPH
        ADDC    A,#0FFH
        MOV     DPH,A
        CLR     C
        RET
;
;s/r BN2BCD - converts a number from binary to binary-decimal form
;enter in (R2,R3),unpacking in (R4,R5,R6)
BN2BCD:                 ;R3R2 -> R6R5R4, R0  R1 .
        MOV     R7,#10H
        MOV     A,#0
        MOV     R4,A
        MOV     R5,A
        MOV     R6,A
BN2CKL: MOV     A,R2
        ADD     A,R2
        MOV     R2,A
        MOV     A,R3
        ADDC    A,R3
        MOV     R3,A
;-     :
        MOV     A,R4
        ADDC    A,R4
        DA      A
        MOV     R4,A
        MOV     A,R5
        ADDC    A,R5
        DA      A
        MOV     R5,A
        MOV     A,R6
        ADDC    A,R6
        DA      A
        MOV     R6,A
;  :
        DJNZ    R7,BN2CKL
        RET
;
;                  
;                          ******
;
;/ DIV42      
;  32:16=16. - 
;. -   (H,L,D,E),
;-  (). -   (DE), - 
;(HL),CY=0 -   .
;   , - .
;
DIV42: MOV  R0,#10H
DCLK:  LCALL HL2
       MOV  R1,0D0H     ;save PSW in R1
       LCALL DE2
       JNC  PER1
       LCALL INXH
;subtraction of the divisor from the remainder
PER1:  LCALL HLMNBC
       JC   PER2
       MOV  0D0H,R1    ;load PSW from R1
PER3:  LCALL INXD
       SJMP PER4
;testing of the bit CY after remainder
;rotation
PER2:  MOV  0D0H,R1
       JC   PER3
;restortion of the remainder
       LCALL DADB
;check of the cycle end
PER4:  DJNZ R0,DCLK
       RET
;
OGRPR:  MOV     R3,#00H
        MOV     R2,#12H
        MOV     R6,#6FH
        MOV     R7,#0EH
;/ OGRAN -  ,  DE,
;,  BC, - B HL:
OGRAN:
        LCALL   DECMBC
        JC      MALO
        JZ      RETOGR
        LCALL   HLCMDE
        JC      MNOGO
RETOGR: RET
MALO:   MOV     A,R3
        MOV     R5,A
        MOV     A,R2
        MOV     R4,A
        RET
MNOGO:  MOV     A,R7
        MOV     R5,A
        MOV     A,R6
        MOV     R4,A
        RET
;
;
;/     
;ABAZE  KBAZE -    DPTR,.  R4R5
;
OBSCH:  MOV     A,R4
        ANL     A,#11100000B
        ADD     A,R5
        RL      A
        RL      A
        RL      A
        RL      A  ; 2-
;     :
        ADD     A,DPL
        MOV     DPL,A
        MOV     A,DPH
        ADDC    A,#0
        MOV     DPH,A
;    BC,- DE:
;(!    BAZE 
;  :, ..,- ,
;, .,.-.)
        MOV     A,R4
        MOV     R0,A  ;.
        MOV     A,#0
        MOVC    A,@A+DPTR
        MOV     R3,A
        MOV     A,#1
        MOVC    A,@A+DPTR
        MOV     R2,A
        MOV     A,#2
        MOVC    A,@A+DPTR
        MOV     R5,A
        MOV     A,#3
        MOVC    A,@A+DPTR
        MOV     R4,A
;DE=-DE+BC:
;       LCALL   BCMNDE
        MOV     DPL,R2
        MOV     DPH,R3  ; R2R3
        LCALL   BCMNDE
        LCALL   BCXGDE
;..  :
        MOV     A,R0   ;.
        ANL     A,#00011111B
        RL      A
        RL      A
        RL      A
        MOV     R0,A  ;R0*R5R4=R0R5R4
        LCALL   MUL21
; R4    256,
;  .  
        CLR     C
        MOV     A,DPL
        SUBB    A,R5
        MOV     R6,A
        MOV     A,DPH
        SUBB    A,R0
        MOV     R7,A
        CLR     C
        MOV     A,R4
        ANL     A,#10000000B
        RL      A
        MOV     R4,A
        CLR     C
        MOV     A,R6
        SUBB    A,R4
        MOV     R6,A
        MOV     A,R7
        SUBB    A,#0
        MOV     R7,A
        RET
;
;
;        .ORG     01000H
        .ORG     00400H
        .END
