;
;       &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
;       &                                                       &
;       &                    &
;       &                                                       &
;       &        35-   C 87C51  AD7714           &
;       &                                                       &
;       &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
;
;
;
;                         
;                            *****
;
R15     .EQU    15
R14     .EQU    14
R13     .EQU    13
R12     .EQU    12
R11     .EQU    11
R10     .EQU    10
R9      .EQU    9
R8      .EQU    8
R7      .EQU    7
R6      .EQU    6
R5      .EQU    5
R4      .EQU    4
R3      .EQU    3
R2      .EQU    2
R1      .EQU    1
R0      .EQU    0
EA      .EQU    0A8H
ACC     .EQU    0E0H
B       .EQU    0F0H
PSW     .EQU    0D0H
SP      .EQU    81H
DPL     .EQU    82H
DPH     .EQU    83H
P0      .EQU    80H
P1      .EQU    90H
P2      .EQU    0A0H
P3      .EQU    0B0H
B.0     .EQU    0F0H
B.1     .EQU    0F1H
B.2     .EQU    0F2H
B.3     .EQU    0F3H
B.4     .EQU    0F4H
B.5     .EQU    0F5H
B.6     .EQU    0F6H
B.7     .EQU    0F7H
ACC.0   .EQU    0E0H
ACC.1   .EQU    0E1H
ACC.2   .EQU    0E2H
ACC.3   .EQU    0E3H
ACC.4   .EQU    0E4H
ACC.5   .EQU    0E5H
ACC.6   .EQU    0E6H
ACC.7   .EQU    0E7H
PSW.0   .EQU    0D0H
PSW.1   .EQU    0D1H
PSW.2   .EQU    0D2H
PSW.3   .EQU    0D3H
PSW.4   .EQU    0D4H
PSW.5   .EQU    0D5H
PSW.6   .EQU    0D6H
PSW.7   .EQU    0D7H
P0.0    .EQU    080H
P0.1    .EQU    081H
P0.2    .EQU    082H
P0.3    .EQU    083H
P0.4    .EQU    084H
P0.5    .EQU    085H
P0.6    .EQU    086H
P0.7    .EQU    087H
P1.0    .EQU    090H
P1.1    .EQU    091H
P1.2    .EQU    092H
P1.3    .EQU    093H
P1.4    .EQU    094H
P1.5    .EQU    095H
P1.6    .EQU    096H
P1.7    .EQU    097H
P2.0    .EQU    0A0H
P2.1    .EQU    0A1H
P2.2    .EQU    0A2H
P2.3    .EQU    0A3H;
P2.4    .EQU    0A4H;
P2.5    .EQU    0A5H;
P2.6    .EQU    0A6H;
P2.7    .EQU    0A7H;
P3.0    .EQU    0B0H;
P3.1    .EQU    0B1H;
P3.2    .EQU    0B2H;
P3.3    .EQU    0B3H;
P3.4    .EQU    0B4H;
P3.5    .EQU    0B5H;
P3.6    .EQU    0B6H;
P3.7    .EQU    0B7H;
;
CLKIND1 .EQU    P1.3
DATIND1 .EQU    P3.7
;
NACHPZU .EQU     0000H
BUFFER  .EQU     NACHPZU+20H
COUNT   .EQU     NACHPZU+23H
SWAPREG .EQU     NACHPZU+24H
COMDREG .EQU     NACHPZU+25H
ASTK    .EQU     NACHPZU+15
BUFFER2 .EQU     NACHPZU+30H
DRDY    .EQU     P1.5
CS      .EQU     P1.0
SCLK    .EQU     P1.4
DIN     .EQU     P1.6
DOUT    .EQU     P1.6
RESADC  .EQU     P1.7
SDATA   .EQU     P1.6
;
;
;
;
;
;                :
;                   *****
;
        .ORG     NACHPZU
        LJMP    RESET
;
RESET:
        MOV       SP,#10H
        MOV       P1,#11111110B         ;#01111111B
        MOV       P3,#11111111B         ;#10010011B
;
        CLR     RESADC
        NOP
        SETB    RESADC
        JB      DRDY,$
;
START_24:
        LCALL   ADSETP56
S1:
        MOV     BUFFER2,#0
        MOV     BUFFER2+1,#0
        MOV     BUFFER2+2,#0
        MOV     BUFFER2+3,#0
        MOV     BUFFER2+4,#0
        MOV     BUFFER2+5,#0
;
        MOV     R2,#0 		;R2=256  
;
S2:
        LCALL   ADC_RD56
        LCALL   SUMMIP          ;
        DJNZ    R2,S2
;
; BUFFER2-BUFFER2+3  256- 24- 
;
        LCALL   RRC_BUF2        ;   2 
        LCALL   RRC_BUF2        ;   4 
        LCALL   RRC_BUF2        ;   8 
        LCALL   RRC_BUF2        ;   16 
        LCALL   RRC_BUF2        ;   32 
        LCALL   RRC_BUF2        ;   64 
        LCALL   RRC_BUF2        ;   128 
        LCALL   RRC_BUF2        ;   256 
;
;  1,5 ,   R7R6R5  
;
        LCALL   RRC_BUF2    ;   
;
        MOV     B,#0
        MOV     R1,#07AH
        MOV     R0,#0CAH    ;BR1R0=007ACA=31434D
        MOV     R4,BUFFER2+2
        MOV     R3,BUFFER2+1
        MOV     R2,BUFFER2+0
        LCALL   MUL63       ;R7R6R5R4R3R2=(BUFFER2+2...+0)*(31434D)
        MOV     B,#0
        MOV     R1,#0F7H
        MOV     R0,#035H    ;BR1R0=00F735H=63285D
        LCALL   DIV63       ;R4R3R2=(BUFFER2+2...+0)*(31434D)/(63285D)
;
        MOV     BUFFER2+2,R4
        MOV     BUFFER2+1,R3
        MOV     BUFFER2+0,R2 ; 
;
        MOV     R7,BUFFER2+2
        MOV     R6,BUFFER2+1
        MOV     R5,BUFFER2+0
;
        MOV     B,#0
;
        MOV     A,R5
        ADD     A,BUFFER2+0
        MOV     R5,A
        MOV     A,R6
        ADDC    A,BUFFER2+1
        MOV     R6,A
        MOV     A,R7
        ADDC    A,BUFFER2+2
        MOV     R7,A
        MOV     A,B
        ADDC    A,#0
        MOV     B,A
;
        MOV     A,R5
        ADD     A,BUFFER2+0
        MOV     R5,A
        MOV     A,R6
        ADDC    A,BUFFER2+1
        MOV     R6,A
        MOV     A,R7
        ADDC    A,BUFFER2+2
        MOV     R7,A
        MOV     A,B
        ADDC    A,#0
        MOV     B,A
;
        LCALL   BN25BCD
;
        LCALL   R7654IN2
;
        LJMP    S1
;
RRC_BUF2:
        CLR     C
        MOV     A,BUFFER2+3
        RRC     A
        MOV     BUFFER2+3,A
        MOV     A,BUFFER2+2
        RRC     A
        MOV     BUFFER2+2,A
        MOV     A,BUFFER2+1
        RRC     A
        MOV     BUFFER2+1,A
        MOV     A,BUFFER2+0
        RRC     A
        MOV     BUFFER2+0,A
        RET
;
SUMMIP:
        MOV     A,BUFFER2+0     ;
        ADD     A,BUFFER+2      ;
        MOV     BUFFER2+0,A
;
        MOV     A,BUFFER2+1     ;
        ADDC    A,BUFFER+1      ;
        MOV     BUFFER2+1,A
;
        MOV     A,BUFFER2+2     ;
        ADDC    A,BUFFER        ;
        MOV     BUFFER2+2,A
;
        MOV     A,BUFFER2+3     ; 
        ADDC    A,#0
        MOV     BUFFER2+3,A
        RET
;
;
R7654IN2:                       ; - _2_5102162
        MOV     A,#0FH
        LCALL   SIMBOL1  ;10-
;
        MOV     A,R7
        SWAP    A
        ANL     A,#00001111B
        LCALL   SIMBOL1  ;9-
;
        MOV     A,#0FH
        LCALL   SIMBOL1  ;8-
;
        MOV     A,R7
        ANL     A,#00001111B
        LCALL   SIMBOL1  ;7-
;
        MOV     A,R6
        SWAP    A
        ANL     A,#00001111B
        LCALL   SIMBOL1  ;6-
        MOV     A,R6
        ANL     A,#00001111B
        LCALL   SIMBOL1  ;5-
;
        MOV     A,R5
        SWAP    A
        ANL     A,#00001111B
        LCALL   SIMBOL1  ;4-
        MOV     A,R5
        ANL     A,#00001111B
        LCALL   SIMBOL1  ;3-
;
        MOV     A,R4
        SWAP    A
        ANL     A,#00001111B
        LCALL   SIMBOL1  ;2-
        MOV     A,R4
        ANL     A,#00001111B
        LCALL   SIMBOL1  ;1-
RETR:
        RET
;
;
ADSETP56:
        MOV     SWAPREG,#00100110B ;0 -  0
                                   ;010 - ..
                                   ;0 -  WR
                                   ;110 - AIN5,AIN6
        MOV     COMDREG,#11000001B ;0 -  ,1-㭨
                                   ;1 -  24 
                                   ;0 -  .
                                   ;0 -  ZERO
                                   ;0001 - .4  F11-F0
        LCALL   ADC_WR
;
        MOV     SWAPREG,#00110110B ;0 -  0
                                   ;011 - ..
                                   ;0 -  WR
                                   ;110 - AIN5,AIN6
        MOV     COMDREG,#10000000B ; .8  F7-F0
                                   ;  000110000000=384D
                                   ;  =
                                   ;2457600/128/384=19200/384=50
                                   ;0001 - .4  F11-F0
        LCALL   ADC_WR
;
        MOV     SWAPREG,#00010110B ;0 -  0
                                   ;001 - .
                                   ;0 -  WR
                                   ;110 - AIN5,AIN6
        MOV     COMDREG,#00100000B ;001 -  
                                   ;000 -  =1
                                   ;0 -  I 
                                   ;0 -   
        LCALL   ADC_WR
;
        JB      DRDY,$
        RET
;
;
ADC_WR:
        MOV     A,SWAPREG
        LCALL    TX_ADC
        MOV     A,COMDREG
        LCALL    TX_ADC
        RET
;
ADC_RD56:
        MOV     SWAPREG,#01011110B ;0 -  0
                                   ;101 - .
                                   ;1 -  RD
                                   ;110 - AIN5,AIN6
ADC_RD:
;       CLR     EA
        MOV     R0,#BUFFER
        JB      DRDY,$
        MOV     A,SWAPREG
        LCALL  TX_ADC
        LCALL  RX_ADC
        MOV     @R0,A
        INC     R0
        LCALL  RX_ADC
        MOV     @R0,A
        INC     R0
        LCALL  RX_ADC
        MOV     @R0,A
;       SETB    EA
        RET
;
TX_ADC:
        MOV     COUNT,#8
TX_ADC_N:
        CLR     SCLK
        RLC     A
        MOV     SDATA,C
        NOP
        NOP
        SETB    SCLK
        NOP
        NOP
        NOP
        DJNZ    COUNT,TX_ADC_N
        SETB    SDATA
        RET
;
RX_ADC:
        MOV     COUNT,#8
RX_ADC_N:
        CLR     SCLK
        NOP
        NOP
        MOV     C,SDATA
        RLC     A
        SETB    SCLK
        NOP
        NOP
        DJNZ    COUNT,RX_ADC_N
        RET
;
;
;.  .-.    BR7R6R5 (0...17FFFFD)
;
BN25BCD:
        MOV     A,B
        JNZ     MO16MLN ;.  >0
        LCALL   BN24BCD
        SJMP    RETBN25
MO16MLN:
        CLR     C
        MOV     A,R5
        SUBB    A,#80H  ;10 000 000D = 989680H
        MOV     R5,A
        MOV     A,R6
        SUBB    A,#96H
        MOV     R6,A
        MOV     A,R7
        SUBB    A,#98H
        MOV     R7,A
        MOV     A,B
        SUBB    A,#0
        MOV     B,A     ;.     0!
        LCALL   BN24BCD
        MOV     A,R7
        ADD     A,#10H
        MOV     R7,A    ; =  + 1
RETBN25:
        RET
;
;     /
;   R7R6R5,  -
;  -  R7R6R5R4
;
BN24BCD:
        MOV     R0,#0
        MOV     R1,#0           ;   4  
;
        MOV     R2,#80H
        MOV     R3,#69H
        MOV     R4,#67H         ;676980H = - 10 000 000
DEC_MIL:
        LCALL   ADD765_432      ; - 10 000 000
        JNC     ED_MIL0         ; CY=0 TO  < 0
        MOV     A,R1            ;    > 0
        ADD     A,#00010000B
        MOV     R1,A            ;- .   1
        SJMP    DEC_MIL
ED_MIL0:
        MOV     R2,#80H
        MOV     R3,#96H
        MOV     R4,#98H         ;989680H = 10 000 000
        LCALL   ADD765_432
;
        MOV     R2,#0C0H
        MOV     R3,#0BDH
        MOV     R4,#0F0H         ;F0BDC0H = - 1 000 000
ED_MIL:
        LCALL   ADD765_432      ; - 1 000 000
        JNC     HUN_TH0         ; CY=0 TO  < 0
        MOV     A,R1            ;    > 0
        ADD     A,#00000001B
        MOV     R1,A            ;- .   1
        SJMP    ED_MIL
HUN_TH0:
        MOV     R2,#40H
        MOV     R3,#42H
        MOV     R4,#0FH         ;0F4240H = 1 000 000
        LCALL   ADD765_432
;
        MOV     R2,#60H
        MOV     R3,#79H
        MOV     R4,#0FEH        ;FE7960H = - 100 000
HUN_TH:
        LCALL   ADD765_432      ; - 100 000
        JNC     DEC_TH0         ; CY=0 TO  < 0
        MOV     A,R0            ;    > 0
        ADD     A,#00010000B
        MOV     R0,A            ;-     1
        SJMP    HUN_TH
DEC_TH0:
        MOV     R2,#0A0H
        MOV     R3,#86H
        MOV     R4,#01H         ;0186A0H = 100 000
        LCALL   ADD765_432
;
        MOV     R2,#0F0H
        MOV     R3,#0D8H
        MOV     R4,#0FFH        ;FFD8F0H = - 10 000
DEC_TH:
        LCALL   ADD765_432      ; - 10 000
        JNC     ED_TH0          ; CY=0 TO  < 0
        MOV     A,R0            ;    > 0
        ADD     A,#00000001B
        MOV     R0,A            ;- .    1
        SJMP    DEC_TH
ED_TH0:
        MOV     R2,#10H
        MOV     R3,#27H
        MOV     R4,#00H         ;002710H = 10 000
        LCALL   ADD765_432
;
        MOV     R2,R5
        MOV     R3,R6
        LCALL   BN2BCD
        MOV     R7,R1
        MOV     R6,R0
        RET
;
ADD765_432:
        CLR     C
        MOV     A,R5
        ADD     A,R2
        MOV     R5,A
        MOV     A,R6
        ADDC    A,R3
        MOV     R6,A
        MOV     A,R7
        ADDC    A,R4
        MOV     R7,A
        RET
;
SIMBOL1:
        ANL     A,#00001111B
        CJNE    A,#0,SIMB11
        MOV     A,#10
        SJMP    SIMB12
SIMB11: CJNE    A,#0FH,SIMB12
        MOV     A,#0
SIMB12: CLR     CLKIND1
        SWAP    A
        ACALL   BIT1
        ACALL   BIT1
        ACALL   BIT1
        ACALL   BIT1
        RET
;
BIT1:   RLC     A
        MOV     DATIND1,C       ;.   -
        SETB    CLKIND1         ; 
        CLR     CLKIND1
        RET
;
;
;     
; H  6- .
;  (.)R1R0   R4(.)R3R2,
;  R7R6R5R4R3R2.
;
MUL63:
        MOV     A,#24   ; 
        MOV     R7,#0   ; 24  
        MOV     R6,#0   ;3   
        MOV     R5,#0   ;  
MUL63_1:
        PUSH    ACC
        MOV     A,R2    ;B A - . 
        RRC     A       ;  . 
        JNC     MUL63_2 ;   0,  
        MOV     A,R5    ;   
        ADD     A,R0    ;,   
        MOV     R5,A    ;/   
        MOV     A,R6
        ADDC    A,R1
        MOV     R6,A
        MOV     A,R7
        ADDC    A,B
        MOV     R7,A
MUL63_2:
        MOV     A,R7
        RRC     A
        MOV     R7,A
        MOV     A,R6
        RRC     A
        MOV     R6,A
        MOV     A,R5
        RRC     A
        MOV     R5,A
        MOV     A,R4
        RRC     A
        MOV     R4,A
        MOV     A,R3
        RRC     A
        MOV     R3,A
        MOV     A,R2    ;  
        RRC     A       ; 
        MOV     R2,A    ; 1  
        POP     ACC
        DJNZ    ACC,MUL63_1
        RET
;
;     R7R6R5R4R3R2
;   BR1R0    
; R4R3R2
;
DIV63:
        MOV     A,#24
DCLK_63:
        PUSH    ACC
        CLR     C
        MOV     A,R2
        RLC     A
        MOV     R2,A
        MOV     A,R3
        RLC     A
        MOV     R3,A
        MOV     A,R4
        RLC     A
        MOV     R4,A
        MOV     A,R5
        RLC     A
        MOV     R5,A
        MOV     A,R6
        RLC     A
        MOV     R6,A
        MOV     A,R7
        RLC     A
        MOV     R7,A
        PUSH    PSW
PER1_63:
        CLR     C
        MOV     A,R5
        SUBB    A,R0
        MOV     R5,A
        MOV     A,R6
        SUBB    A,R1
        MOV     R6,A
        MOV     A,R7
        SUBB    A,B
        MOV     R7,A
        JC      PER2_63
        POP     PSW
PER3_63:
        INC     R2
        SJMP    PER4_63
PER2_63:
        POP     PSW
        JC      PER3_63
        MOV     A,R5
        ADD     A,R0
        MOV     R5,A
        MOV     A,R6
        ADDC    A,R1
        MOV     R6,A
        MOV     A,R7
        ADDC    A,B
        MOV     R7,A
PER4_63:
        POP     ACC
        DJNZ    ACC,DCLK_63
        RET
;
;s/r BN2BCD - converts a number from binary to binary-decimal form
;enter in (R2,R3),unpacking in (R4,R5,R6)
BN2BCD:                 ;R3R2 -> R6R5R4, R0  R1 .
        MOV     R7,#10H
        MOV     A,#0
        MOV     R4,A
        MOV     R5,A
        MOV     R6,A
BN2CKL: MOV     A,R2
        ADD     A,R2
        MOV     R2,A
        MOV     A,R3
        ADDC    A,R3
        MOV     R3,A
;-     :
        MOV     A,R4
        ADDC    A,R4
        DA      A
        MOV     R4,A
        MOV     A,R5
        ADDC    A,R5
        DA      A
        MOV     R5,A
        MOV     A,R6
        ADDC    A,R6
        DA      A
        MOV     R6,A
;  :
        DJNZ    R7,BN2CKL
        RET
;
;
;                20 
;                     *****
;
DEL20:
        MOV     R1,#0FFH
LPEX:   MOV     R2,#05H
LPIN:   DJNZ    R2,LPIN
        DJNZ    R1,LPEX
        RET
;
        .ORG     00800H
        .END
